package com.hh.hhomc.http;

import android.content.Context;

import com.common.lib_base.common.local.AppLocalConfigHandler;
import com.common.lib_base.utils.LogUtils;
import com.google.gson.Gson;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;

import okhttp3.Interceptor;
import okhttp3.MediaType;
import okhttp3.Protocol;
import okhttp3.Request;
import okhttp3.Response;
import okhttp3.ResponseBody;

/**
 * Date: 2022/7/25 0025 14:22
 * Description:
 */
public class CommonAddAndHandleInterceptor implements Interceptor {

    // 当前类名
    public String mTag = getClass().getSimpleName() + "--";

    private Gson mGson;
    private Context mContext;
//    IAppLocalConfig localConfig;
    String token;
    public static final int ERROR_TOKEN= 100003;
    public CommonAddAndHandleInterceptor() {

    }

    public CommonAddAndHandleInterceptor(Context context) {
        this.mContext = context;
    }

    public CommonAddAndHandleInterceptor(Context context, Gson gson) {
        this.mContext = context;
        this.mGson = gson;
    }

    // 根据服务端定义，有的是data，有的是result
    String serverResult = "data";
    // 根据服务端定义，有的是message，有的是msg
    String message = "msg";

    @Override
    public Response intercept(Chain chain) throws IOException {

        Response response;

        Request newRequest = null;

        try {
//            token = localConfig.getToken("");
//            LogUtils.i(mTag + "Token:" + token);

            //请求头添加token
            newRequest = chain.request().newBuilder()
//                        .addHeader("Content-Type", "application/x-www-form-urlencoded; charset=utf-8")
                    .addHeader("Content-Type", "text/html; charset=utf-8")
//                        .addHeader("gray-version","develop-k4.77")
//                        .addHeader("Content-Type", "text/html")
//                        .addHeader("charset","UTF-8")
//                    .addHeader("token", token)
                    .addHeader("loginType", "app")
                    .build();
            // 需要对结果处理，故注释
//            return chain.proceed(newRequest);
        } catch (Exception e) {
            e.printStackTrace();
            LogUtils.i(mTag + "intercept:" + e.getMessage());
        }


        //调用拦截器处理获取结果
        /**
         * 使用OkHttpClient会出现重复请求问题
         * 最终排查到日志拦截器里重复使用chain.proceed(request)导致
         */
        Response originalResponse = chain.proceed(newRequest);
        LogUtils.i(mTag + "调用拦截器处理获取结果originalResponse" + originalResponse);



        return originalResponse;

//        return  originalResponse.newBuilder().body(responseBody).build();


//        return chain.proceed(request);
    }
}

